diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -6897,23 +8392,29 @@
       LDM_REG(16384, 14);
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
+
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x9b0)
     {
       // LDMIB Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I + 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
@@ -6933,12 +8434,21 @@
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
         if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + dataTicksAccessSeq32(address);
+
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
       if(!(opcode & (1 << base)))
         reg[base].I = temp;
     }
@@ -6946,9 +8456,11 @@
   CASE_16(0x9d0)
     {
       // LDMIB Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -6968,18 +8480,16 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         CPUSwitchMode(reg[17].I & 0x1f, false);
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -7012,17 +8522,25 @@
           LDM_REG(8192, 13);
           LDM_REG(16384, 14);
         }
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x9f0)
     {
       // LDMIB Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I +
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -7042,10 +8560,6 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if(!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);      
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
@@ -7054,9 +8568,11 @@
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -7092,13 +8608,18 @@
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;    
   CASE_256(0xa00)
     {
       // B <offset>
-      clockTicks += 3;
       int offset = opcode & 0x00FFFFFF;
       if(offset & 0x00800000) {
         offset |= 0xFF000000;
@@ -7107,12 +8628,16 @@
       reg[15].I += offset;
       armNextPC = reg[15].I;
       reg[15].I += 4;
+      ARM_PREFETCH;
+      clockTicks = codeTicksAccessSeq32(armNextPC) + 1;
+      clockTicks += 2 + codeTicksAccess32(armNextPC) +
+          codeTicksAccessSeq32(armNextPC);
+      busPrefetchCount=0;
     }
     break;
   CASE_256(0xb00)
     {
       // BL <offset>
-      clockTicks += 3;
       int offset = opcode & 0x00FFFFFF;
       if(offset & 0x00800000) {
         offset |= 0xFF000000;
@@ -7122,12 +8647,21 @@
       reg[15].I += offset;
       armNextPC = reg[15].I;
       reg[15].I += 4;
+      ARM_PREFETCH;
+      clockTicks = codeTicksAccessSeq32(armNextPC) + 1;
+      clockTicks += 2 + codeTicksAccess32(armNextPC) +
+          codeTicksAccessSeq32(armNextPC);
+      busPrefetchCount=0;
     }
     break;
   CASE_256(0xf00)
     // SWI <comment>
-    clockTicks += 3;
-    CPUSoftwareInterrupt(opcode & 0x00FFFFFF);      
+    clockTicks = codeTicksAccessSeq32(armNextPC) + 1;
+    clockTicks += 2 + codeTicksAccess32(armNextPC) +
+        codeTicksAccessSeq32(armNextPC);
+    busPrefetchCount=0;
+    CPUSoftwareInterrupt(opcode & 0x00FFFFFF);  
+
     break;
 #ifdef GP_SUPPORT
   case 0xe11:
@@ -7162,3 +8696,6 @@
     // END
   }
 }
+
+if (clockTicks == 0)
+  clockTicks = codeTicksAccessSeq32(oldArmNextPC) + 1;
diff -urN ../VisualBoyAdvance-1.7.2/src/armdis.cpp ./src/armdis.cpp
--- ../VisualBoyAdvance-1.7.2/src/armdis.cpp	2004-05-13 23:34:51 +0900
+++ ./src/armdis.cpp	2006-01-07 04:40:08 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -117,8 +117,8 @@
   {0xfa00, 0x5800, "ldr%b %r0, [%r3, %r6]"},
   // Format 8
   {0xfe00, 0x5200, "strh %r0, [%r3, %r6]"},
-  {0xfe00, 0x5600, "ldrh %r0, [%r3, %r6]"},
-  {0xfe00, 0x5a00, "ldsb %r0, [%r3, %r6]"},
+  {0xfe00, 0x5600, "ldsb %r0, [%r3, %r6]"},
+  {0xfe00, 0x5a00, "ldrh %r0, [%r3, %r6]"},
   {0xfe00, 0x5e00, "ldsh %r0, [%r3, %r6]"},
   // Format 9
   {0xe800, 0x6000, "str%B %r0, [%r3, %p]"},
diff -urN ../VisualBoyAdvance-1.7.2/src/bios.cpp ./src/bios.cpp
--- ../VisualBoyAdvance-1.7.2/src/bios.cpp	2004-05-13 23:34:20 +0900
+++ ./src/bios.cpp	2006-04-30 23:35:05 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -70,7 +70,7 @@
   }
 #endif
 
-  s32 a = -((s32)(reg[0].I * reg[0].I)) >> 14; 
+  s32 a =  -(((s32)(reg[0].I*reg[0].I)) >> 14);
   s32 b = ((0xA9 * a) >> 14) + 0x390;
   b = ((b * a) >> 14) + 0x91C;
   b = ((b * a) >> 14) + 0xFB6;
@@ -78,7 +78,8 @@
   b = ((b * a) >> 14) + 0x2081;
   b = ((b * a) >> 14) + 0x3651;
   b = ((b * a) >> 14) + 0xA2F9;
-  reg[0].I = (reg[0].I * b) >> 16;
+  a = ((s32)reg[0].I * b) >> 16;
+  reg[0].I = a;
 
 #ifdef DEV_VERSION
   if(systemVerbose & VERBOSE_SWI) {
@@ -99,36 +100,33 @@
   }
 #endif
   
-  s16 x = reg[0].I;
-  s16 y = reg[1].I;
-  
+  s32 x = reg[0].I;
+  s32 y = reg[1].I;
+  u32 res = 0;
   if (y == 0) {
-    reg[0].I = 0x8000 & x;
-    reg[3].I = 0x170;
+    res = ((x>>16) & 0x8000);
   } else {
     if (x == 0) {
-      reg[0].I = (0x8000 & y) + 0x4000;
-      reg[3].I = 0x170;
+      res = ((y>>16) & 0x8000) + 0x4000;
     } else {
-      if (abs(x) > abs(y)) {
+		if ((abs(x) > abs(y)) || ((abs(x) == abs(y)) && (!((x<0) && (y<0))))) {
         reg[1].I = x;
         reg[0].I = y << 14;
         BIOS_Div();
         BIOS_ArcTan();
         if (x < 0)
-          reg[0].I = 0x8000 + reg[0].I;
+          res = 0x8000 + reg[0].I;
         else
-          reg[0].I = ((y & 0x8000) << 1 ) + reg[0].I;
-        reg[3].I = 0x170;
+          res = (((y>>16) & 0x8000)<<1) + reg[0].I;
       } else {
         reg[0].I = x << 14;
         BIOS_Div();
         BIOS_ArcTan();
-        reg[0].I = (0x4000 + (y & 0x8000)) - reg[0].I;
-        reg[3].I = 0x170;
+        res = (0x4000 + ((y>>16) & 0x8000)) - reg[0].I;
       }
     }
   }
+  reg[0].I = res;
   
 #ifdef DEV_VERSION
   if(systemVerbose & VERBOSE_SWI) {
@@ -136,7 +134,7 @@
         reg[0].I);
   }
 #endif
-} 
+}  
 
 void BIOS_BitUnPack()
 {
@@ -155,7 +153,11 @@
   u32 header = reg[2].I;
   
   int len = CPUReadHalfWord(header);
-  // check address
+    // check address
+  if(((source & 0xe000000) == 0) ||
+     ((source + len) & 0xe000000) == 0)
+    return;
+
   int bits = CPUReadByte(header+2);
   int revbits = 8 - bits; 
   // u32 value = 0;
@@ -179,7 +181,7 @@
         break;
       u32 d = b & mask;
       u32 temp = d >> bitcount;
-      if(!temp && addBase) {
+      if(d || addBase) {
         temp += base;
       }
       data |= temp << bitwritecount;
@@ -196,6 +198,11 @@
   }
 }
 
+void BIOS_GetBiosChecksum()
+{
+  reg[0].I=0xBAAE187F;
+}
+
 void BIOS_BgAffineSet()
 {
 #ifdef DEV_VERSION  
@@ -280,7 +287,7 @@
     dest &= 0xFFFFFFFC;
     // fill ?
     if((cnt >> 24) & 1) {
-      u32 value = CPUReadMemory(source);
+        u32 value = (source>0x0EFFFFFF ? 0x1CAD1CAD : CPUReadMemory(source));
       while(count) {
         CPUWriteMemory(dest, value);
         dest += 4;
@@ -289,7 +296,7 @@
     } else {
       // copy
       while(count) {
-        CPUWriteMemory(dest, CPUReadMemory(source));
+        CPUWriteMemory(dest, (source>0x0EFFFFFF ? 0x1CAD1CAD : CPUReadMemory(source)));
         source += 4;
         dest += 4;
         count--;
@@ -298,7 +305,7 @@
   } else {
     // 16-bit fill?
     if((cnt >> 24) & 1) {
-      u16 value = CPUReadHalfWord(source);
+      u16 value = (source>0x0EFFFFFF ? 0x1CAD : CPUReadHalfWord(source));
       while(count) {
         CPUWriteHalfWord(dest, value);
         dest += 2;
@@ -307,7 +314,7 @@
     } else {
       // copy
       while(count) {
-        CPUWriteHalfWord(dest, CPUReadHalfWord(source));
+        CPUWriteHalfWord(dest, (source>0x0EFFFFFF ? 0x1CAD : CPUReadHalfWord(source)));
         source += 2;
         dest += 2;
         count--;
@@ -343,7 +350,7 @@
   if((cnt >> 24) & 1) {
     while(count > 0) {
       // BIOS always transfers 32 bytes at a time
-      u32 value = CPUReadMemory(source);
+      u32 value = (source>0x0EFFFFFF ? 0xBAFFFFFB : CPUReadMemory(source));
       for(int i = 0; i < 8; i++) {
         CPUWriteMemory(dest, value);
         dest += 4;
@@ -355,7 +362,7 @@
     while(count > 0) {
       // BIOS always transfers 32 bytes at a time
       for(int i = 0; i < 8; i++) {
-        CPUWriteMemory(dest, CPUReadMemory(source));
+        CPUWriteMemory(dest, (source>0x0EFFFFFF ? 0xBAFFFFFB :CPUReadMemory(source)));
         source += 4;
         dest += 4;
       }
@@ -548,7 +555,7 @@
 
   u32 treeStart = source;
 
-  source += (treeSize<<1) + 1;
+  source += ((treeSize+1)<<1)-1; // minus because we already skipped one byte
   
   int len = header >> 8;
 
@@ -866,6 +873,8 @@
 {
   // no need to trace here. this is only called directly from GBA.cpp
   // to emulate bios initialization
+
+  CPUUpdateRegister(0x0, 0x80);
   
   if(flags) {
     if(flags & 0x01) {
@@ -891,18 +900,16 @@
 
     if(flags & 0x80) {
       int i;
-      for(i = 0; i < 8; i++)
+      for(i = 0; i < 0x10; i++)
         CPUUpdateRegister(0x200+i*2, 0);
 
-      CPUUpdateRegister(0x202, 0xFFFF);
-
-      for(i = 0; i < 8; i++)
+      for(i = 0; i < 0xF; i++)
         CPUUpdateRegister(0x4+i*2, 0);
 
-      for(i = 0; i < 16; i++)
+      for(i = 0; i < 0x20; i++)
         CPUUpdateRegister(0x20+i*2, 0);
 
-      for(i = 0; i < 24; i++)
+      for(i = 0; i < 0x18; i++)
         CPUUpdateRegister(0xb0+i*2, 0);
 
       CPUUpdateRegister(0x130, 0);
@@ -965,7 +972,7 @@
   u32 source = reg[0].I;
   u32 dest = reg[1].I;
 
-  u32 header = CPUReadMemory(source);
+  u32 header = CPUReadMemory(source & 0xFFFFFFFC);
   source += 4;
 
   if(((source & 0xe000000) == 0) ||
@@ -1034,7 +1041,7 @@
   u32 source = reg[0].I;
   u32 dest = reg[1].I;
 
-  u32 header = CPUReadMemory(source);
+  u32 header = CPUReadMemory(source & 0xFFFFFFFC);
   source += 4;
 
   if(((source & 0xe000000) == 0) ||
diff -urN ../VisualBoyAdvance-1.7.2/src/bios.h ./src/bios.h
--- ../VisualBoyAdvance-1.7.2/src/bios.h	2004-05-13 22:56:47 +0900
+++ ./src/bios.h	2006-04-30 23:35:05 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -23,6 +23,7 @@
 extern void BIOS_ArcTan();
 extern void BIOS_ArcTan2();
 extern void BIOS_BitUnPack();
+extern void BIOS_GetBiosChecksum();
 extern void BIOS_BgAffineSet();
 extern void BIOS_CpuSet();
 extern void BIOS_CpuFastSet();
diff -urN ../VisualBoyAdvance-1.7.2/src/elf.cpp ./src/elf.cpp
--- ../VisualBoyAdvance-1.7.2/src/elf.cpp	2004-05-13 23:34:08 +0900
+++ ./src/elf.cpp	2006-06-08 23:12:18 +0900
@@ -820,7 +820,7 @@
     *bytesRead = 1;
     return NULL;
   }
-  *bytesRead = strlen((char *)data) + 1;
+  *bytesRead = (int)strlen((char *)data) + 1;
   return (char *)data;
 }
 
@@ -961,8 +961,7 @@
     data += bytes;
     break;
   case DW_FORM_ref_addr:
-    attr->value = (elfDebugInfo->infodata + elfRead4Bytes(data)) -
-      elfGetCompileUnitForData(data)->top;
+    attr->value = (u32)((elfDebugInfo->infodata + elfRead4Bytes(data)) - elfGetCompileUnitForData(data)->top);
     data += 4;
     break;
   case DW_FORM_ref4:
@@ -970,11 +969,7 @@
     data += 4;
     break;
   case DW_FORM_ref_udata:
-    attr->value = (elfDebugInfo->infodata +
-                   (elfGetCompileUnitForData(data)->top -
-                    elfDebugInfo->infodata) +
-                   elfReadLEB128(data, &bytes)) -
-      elfCurrentUnit->top;
+    attr->value = (u32)((elfDebugInfo->infodata + (elfGetCompileUnitForData(data)->top - elfDebugInfo->infodata) + elfReadLEB128(data, &bytes)) - elfCurrentUnit->top);
     data += bytes;
     break;    
   case DW_FORM_indirect:
@@ -1070,7 +1065,7 @@
   ELFcie *cies = NULL;
   
   while(data < end) {
-    u32 offset = data - topOffset;
+    u32 offset = (u32)(data - topOffset);
     u32 len = elfRead4Bytes(data);
     data += 4;
 
@@ -1110,7 +1105,7 @@
       cie->returnAddress = *data++;
 
       cie->data = data;
-      cie->dataLen = dataEnd - data;
+      cie->dataLen = (u32)(dataEnd - data);
     } else {
       ELFfde *fde = (ELFfde *)calloc(1, sizeof(ELFfde));
 
@@ -1136,7 +1131,7 @@
       data += 4;
 
       fde->data = data;
-      fde->dataLen = dataEnd - data;
+      fde->dataLen = (u32)(dataEnd - data);
 
       if((elfFdeCount %10) == 0) {
         elfFdes = (ELFfde **)realloc(elfFdes, (elfFdeCount+10) *
@@ -2659,6 +2654,7 @@
         memcpy(&workRAM[READ32LE(&ph->paddr) & 0x3ffff],
                data + READ32LE(&ph->offset),
                READ32LE(&ph->filesz));
+        size += READ32LE(&ph->filesz);
       }      
     } else {
       if(READ32LE(&ph->paddr) >= 0x8000000 &&
@@ -2708,6 +2704,7 @@
           memcpy(&workRAM[READ32LE(&sh[i]->addr) & 0x3ffff], data +
                  READ32LE(&sh[i]->offset),
                  READ32LE(&sh[i]->size));
+                   size += READ32LE(&sh[i]->size);
         }      
       } else {
         if(READ32LE(&sh[i]->addr) >= 0x8000000 &&
@@ -2760,7 +2757,7 @@
     
     while(ddata < end) {
       unit = elfParseCompUnit(ddata, abbrevdata);
-      unit->offset = ddata-debugdata;
+      unit->offset = (u32)(ddata-debugdata);
       elfParseLineInfo(unit, data);
       if(last == NULL)
         elfCompileUnits = unit;
diff -urN ../VisualBoyAdvance-1.7.2/src/expr.l ./src/expr.l
--- ../VisualBoyAdvance-1.7.2/src/expr.l	2002-10-20 22:03:12 +0900
+++ ./src/expr.l	2006-09-04 06:52:25 +0900
@@ -4,6 +4,7 @@
 #ifndef __GNUC__
 #include <io.h>
 #define isatty _isatty
+#define fileno _fileno
 #endif
 
 char *exprString;
diff -urN ../VisualBoyAdvance-1.7.2/src/exprNode.cpp ./src/exprNode.cpp
--- ../VisualBoyAdvance-1.7.2/src/exprNode.cpp	2004-05-13 23:33:47 +0900
+++ ./src/exprNode.cpp	2006-09-04 06:52:25 +0900
@@ -25,6 +25,10 @@
 #include "elf.h"
 #include "exprNode.h"
 
+#ifndef __GNUC__
+#define strdup _strdup
+#endif
+
 extern char *yytext;
 
 #define debuggerReadMemory(addr) \
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp ./src/gb/GB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp	2004-05-14 04:35:26 +0900
+++ ./src/gb/GB.cpp	2006-08-25 22:30:09 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -40,6 +40,7 @@
 extern bool speedup;
 
 bool gbUpdateSizes();
+bool inBios = false;
 
 // debugging
 bool memorydebug = false;
@@ -51,6 +52,7 @@
 void (*mapper)(u16,u8) = NULL;
 void (*mapperRAM)(u16,u8) = NULL;
 u8 (*mapperReadRAM)(u16) = NULL;
+void (*mapperUpdateClock)() = NULL;
 
 // registers
 gbRegister PC;
@@ -59,7 +61,7 @@
 gbRegister BC;
 gbRegister DE;
 gbRegister HL;
-u16 IFF;
+u16 IFF = 0;
 // 0xff04
 u8 register_DIV   = 0;
 // 0xff05
@@ -121,29 +123,79 @@
 
 // state variables
 
+// general
+int clockTicks = 0;
+bool gbSystemMessage = false;
+int gbGBCColorType = 0;
+int gbHardware = 0;
+int gbRomType = 0;
+int gbRemainingClockTicks = 0;
+int gbOldClockTicks = 0;
+int gbIntBreak = 0;
+int gbInterruptLaunched = 0;
+u8 gbCheatingDevice = 0; // 1 = GS, 2 = GG
+// breakpoint
+bool breakpoint = false;
 // interrupt
-int gbInterrupt = 0;
+int gbInt48Signal = 0;
 int gbInterruptWait = 0;
 // serial
 int gbSerialOn = 0;
 int gbSerialTicks = 0;
 int gbSerialBits = 0;
 // timer
-int gbTimerOn = 0;
-int gbTimerTicks = 0;
-int gbTimerClockTicks = 0;
+bool gbTimerOn = false;
+int gbTimerTicks = GBTIMER_MODE_0_CLOCK_TICKS;
+int gbTimerClockTicks = GBTIMER_MODE_0_CLOCK_TICKS;
 int gbTimerMode = 0;
+bool gbIncreased = false;
+// The internal timer is always active, and it is
+// not reset by writing to register_TIMA/TMA, but by
+// writing to register_DIV...
+int gbInternalTimer = 0x55;
+const u8 gbTimerMask [4] = {0xff, 0x3, 0xf, 0x3f};
+const u8 gbTimerBug [8] = {0x80, 0x80, 0x02, 0x02, 0x0, 0xff, 0x0, 0xff}; 
+bool gbTimerModeChange = false;
+bool gbTimerOnChange = false;
 // lcd
+bool gbScreenOn = true;
 int gbLcdMode = 2;
-int gbLcdTicks = GBLCD_MODE_2_CLOCK_TICKS;
-int gbLcdLYIncrementTicks = 0;
+int gbLcdModeDelayed = 2;
+int gbLcdTicks = GBLCD_MODE_2_CLOCK_TICKS-1;
+int gbLcdTicksDelayed = GBLCD_MODE_2_CLOCK_TICKS;
+int gbLcdLYIncrementTicks = 114;
+int gbLcdLYIncrementTicksDelayed = 115;
+int gbScreenTicks = 0;
+u8 gbSCYLine[300];
+u8 gbSCXLine[300];
+u8 gbBgpLine[300];
+u8 gbObp0Line [300];
+u8 gbObp1Line [300];
+u8 gbSpritesTicks [300];
+u8 oldRegister_WY;
+bool gbLYChangeHappened = false;
+bool gbLCDChangeHappened = false;
+int gbLine99Ticks = 1;
+int gbRegisterLYLCDCOffOn = 0;
+int inUseRegister_WY = 0;
+
+// Used to keep track of the line that ellapse
+// when screen is off
+int gbWhiteScreen = 0;
+bool gbBlackScreen = false;
+int register_LCDCBusy = 0;
+
 // div
 int gbDivTicks = GBDIV_CLOCK_TICKS;
 // cgb
 int gbVramBank = 0;
 int gbWramBank = 1;
-int gbHdmaSource = 0x0000;
-int gbHdmaDestination = 0x8000;
+//sgb
+bool gbSgbResetFlag = false;
+// gbHdmaDestination is 0x99d0 on startup (tested on HW)
+// but I'm not sure what gbHdmaSource is...
+int gbHdmaSource = 0x99d0;
+int gbHdmaDestination = 0x99d0;
 int gbHdmaBytes = 0x0000;
 int gbHdmaOn = 0;
 int gbSpeed = 0;
@@ -158,6 +210,7 @@
 int gbSynchronizeTicks = GBSYNCHRONIZE_CLOCK_TICKS;
 // emulator features
 int gbBattery = 0;
+bool gbBatteryError = false;
 int gbCaptureNumber = 0;
 bool gbCapture = false;
 bool gbCapturePrevious = false;
@@ -185,7 +238,7 @@
 };
 
 int gbRamSizes[6] = { 0x00000000, // 0K
-                      0x00000800, // 2K
+                      0x00002000, // 2K  // Changed to 2000 to avoid problems with gbMemoryMap...
                       0x00002000, // 8K
                       0x00008000, // 32K
                       0x00020000, // 128K
@@ -215,9 +268,9 @@
     1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,  // a
     1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,  // b
     2, 3, 3, 4, 3, 4, 2, 4, 2, 4, 3, 2, 3, 6, 2, 4,  // c
-    2, 3, 3, 0, 3, 4, 2, 4, 2, 4, 3, 0, 3, 0, 2, 4,  // d
-    3, 3, 2, 0, 0, 4, 2, 4, 4, 1, 4, 0, 0, 0, 2, 4,  // e
-    3, 3, 2, 1, 0, 4, 2, 4, 3, 2, 4, 1, 0, 0, 2, 4   // f
+    2, 3, 3, 1, 3, 4, 2, 4, 2, 4, 3, 1, 3, 1, 2, 4,  // d
+    3, 3, 2, 1, 1, 4, 2, 4, 4, 1, 4, 1, 1, 1, 2, 4,  // e
+    3, 3, 2, 1, 1, 4, 2, 4, 3, 2, 4, 1, 0, 1, 2, 4   // f
 };
 
 int gbCyclesCB[] = {
@@ -230,14 +283,14 @@
     2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // 5
     2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // 6
     2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // 7
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // 8
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // 9
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // a
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // b
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // c
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // d
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2,  // e
-    2, 2, 2, 2, 2, 2, 3, 2, 2, 2, 2, 2, 2, 2, 3, 2   // f
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2,  // 8
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2,  // 9
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2,  // a
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2,  // b
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2,  // c
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2,  // d
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2,  // e
+    2, 2, 2, 2, 2, 2, 4, 2, 2, 2, 2, 2, 2, 2, 4, 2   // f
 };
 
 u16 DAATable[] = {
@@ -499,7 +552,7 @@
   0x9250,0x9350,0x9450,0x9550,0x9650,0x9750,0x9850,0x9950,
 };
 
-u8 ZeroTable[] = {
+u8 ZeroTable[256] = {
   0x80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
@@ -536,7 +589,8 @@
 #define GBSAVE_GAME_VERSION_8 8
 #define GBSAVE_GAME_VERSION_9 9
 #define GBSAVE_GAME_VERSION_10 10
-#define GBSAVE_GAME_VERSION GBSAVE_GAME_VERSION_10
+#define GBSAVE_GAME_VERSION_11 11
+#define GBSAVE_GAME_VERSION GBSAVE_GAME_VERSION_11
 
 int inline gbGetValue(int min,int max,int v)
 {
@@ -596,45 +650,72 @@
 
 void gbDoHdma()
 {
-  gbCopyMemory(gbHdmaDestination,
-               gbHdmaSource,
+
+  gbCopyMemory((gbHdmaDestination & 0x1ff0) | 0x8000,
+               gbHdmaSource & 0xfff0,
                0x10);
-  
+
   gbHdmaDestination += 0x10;
+  if (gbHdmaDestination == 0xa000)
+    gbHdmaDestination = 0x8000;
+
   gbHdmaSource += 0x10;
+  if (gbHdmaSource == 0x8000)
+    gbHdmaSource = 0xa000;
   
-  register_HDMA2 += 0x10;
-  if(register_HDMA2 == 0x00)
-    register_HDMA1++;
-  
-  register_HDMA4 += 0x10;
-  if(register_HDMA4 == 0x00)
-    register_HDMA3++;
+  register_HDMA2 = gbHdmaSource & 0xff;
+  register_HDMA1 = gbHdmaSource>>8;
+  
+  register_HDMA4 = gbHdmaDestination & 0xff;
+  register_HDMA3 = gbHdmaDestination>>8;
   
-  if(gbHdmaDestination == 0x96b0)
-    gbHdmaBytes = gbHdmaBytes;
   gbHdmaBytes -= 0x10;
-  register_HDMA5--;
+  gbMemory[0xff55] = --register_HDMA5;
   if(register_HDMA5 == 0xff)
     gbHdmaOn = 0;
+
+// We need to add the dmaClockticks for HDMA !
+  if(gbSpeed)
+    gbDmaTicks = 17;
+  else
+    gbDmaTicks = 9;
+
+  if (IFF & 0x80)
+    gbDmaTicks++;
+
 }
 
 // fix for Harley and Lego Racers
 void gbCompareLYToLYC()
 {
-  if(register_LY == register_LYC) {
-    // mark that we have a match
-    register_STAT |= 4;
+  if(register_LCDC & 0x80) {
+    if(register_LY == register_LYC) {
+
+      // mark that we have a match
+      register_STAT |= 4;
     
-    // check if we need an interrupt
-    if((register_STAT & 0x40) && (register_IE & 2))
-      gbInterrupt |= 2;
-  } else // no match
-    register_STAT &= 0xfb;
+      // check if we need an interrupt
+      if (register_STAT & 0x40)
+      {
+        // send LCD interrupt only if no interrupt 48h signal...
+        if (!gbInt48Signal)
+        {
+          register_IF |=2;
+        }
+        gbInt48Signal |= 8;
+      }
+    }
+    else // no match
+    {
+      register_STAT &= 0xfb;
+      gbInt48Signal &=~8;
+    }
+  }
 }
 
 void  gbWriteMemory(register u16 address, register u8 value)
 {
+
   if(address < 0x8000) {
 #ifndef FINAL_VERSION    
     if(memorydebug && (address>0x3fff || address < 0x2000)) {
@@ -643,17 +724,31 @@
           value,
           PC.W);
     }
+
 #endif
     if(mapper)
       (*mapper)(address, value);
     return;
+
   }
-   
+
   if(address < 0xa000) {
-    gbMemoryMap[address>>12][address&0x0fff] = value;
+    // No access to Vram during mode 3
+    // (used to emulate the gfx differences between GB & GBC-GBA/SP in Stunt Racer)
+    if ((gbLcdModeDelayed !=3) ||
+    // This part is used to emulate a small difference between hardwares
+    // (check 8-in-1's arrow on GBA/GBC to verify it)
+       ((register_LY == 0) && ((gbHardware & 0xa) && (gbScreenOn==false) &&
+       (register_LCDC & 0x80)) &&
+       (gbLcdLYIncrementTicksDelayed ==(GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS))))
+      gbMemoryMap[address>>12][address&0x0fff] = value;
     return;
   }
-  
+
+  // Used for the mirroring of 0xC000 in 0xE000
+  if ((address >= 0xe000) && (address < 0xfe00))
+    address &= ~0x2000;
+
   if(address < 0xc000) {
 #ifndef FINAL_VERSION
     if(memorydebug) {
